
import objc
from Foundation import *
from AppKit import *

from PyObjCTools import NibClassBuilder

import os, string, iTunes

NibClassBuilder.extractClasses("CDInfoDocument", bundle=NSBundle.mainBundle())

class ITunesCommunication(NibClassBuilder.AutoBaseClass):
    def init(self):
        self = super(ITunesCommunication, self).init()
        if self is None:
            return None
        self.itunes = iTunes.iTunes()
        self.nStep = 0
        return self

    def onAgree_(self, obj):
        document = obj.window().windowController().document()
        document.enableNextButton_(1)

    def getITunesPlayList(self):
        playlist = self.itunes.make(new = iTunes.user_playlist)
        self.itunes.set(playlist.name, to="Lingea conversation")
        return playlist

    def getDiskName(self):
        DIR = "/Volumes"
        for f in os.listdir(DIR):
            if os.path.islink(os.path.join(DIR, f)):
                return f
        return None

    def getPath(self,document):
        folder = document.getResPath()
        #folder = folder.replace(" ", "\ ")
        folder = string.join(string.split(folder,'/'), ':')
        if folder[:9] == ':Volumes:':
            folder = folder[9:]
        else:
            disc = self.getDiskName()
            if disc is None:
                folder = 'None'
            else:
                folder = disc + ':' + folder[1:]
        return folder

    def changeScreen(self, obj):
        document = obj.window().windowController().document()
        if self.nStep == 0:
            document.setTitleText_('Welcome')
            document.enableBackButton_(0)
            document.setNextButton()
            document.setWelcome()
        if self.nStep == 1:
            document.showAgree_(1)
            document.enableNextButton_(0)
            document.setTitleText_('Licence')
            document.enableBackButton_(1)
            document.setInstallButton()
            document.setLicence()
        if self.nStep == 2:
            self.askITunes_(obj)

    def onBack_(self, obj):
        if self.nStep >= 1:
            self.nStep -= 1
        self.changeScreen(obj)
		
    def onNext_(self, obj):
        self.nStep += 1
        self.changeScreen(obj)

    def getIPodPath(self):
        DIR = "/Volumes"
        for f in os.listdir(DIR):
            path = os.path.join(os.path.join(DIR, f),"iPod_Control/Device/SysInfo")
            if os.path.exists(path):
                print os.path.join(DIR, f)
                path = os.path.join(DIR, f)
                #path = path.replace(" ", "\ ")
                return path
        return None

    def getFilesCount(self, dir):
        files = os.listdir(dir)
        count = len(files)
        return count

    def repairPath(self, path):
        path = path.replace(" ","\ ")
        path = path.replace("\'","\\'")
        return path

    def askITunes_(self, obj):
        print "I'm in askITunes"
        document = obj.window().windowController().document()
        document.enableBackButton_(0)
        document.enableNextButton_(0)
        document.showAgree_(0)
        iPodDir = self.getIPodPath()
        if iPodDir is None:
            document.messageBox_("Cannot find iPod. Please ensure, you have checked \"Enable disk use\" in iPod settings.")
            document.close()
            return
        if self.itunes is None:
            document.messageBox_("Cannot find iTunes instaled on this Mac.")
            document.close()
            return			
        self.itunes.start()
        # Try to get the iTunes info
        playList = self.getITunesPlayList()
        if playList is None:
            print "Invalid playlist, returnning ..."
            return
        path = self.getPath(document)
        if path is None:
            print "Invalid path, returning ..."
            return
        path = path + ":audio:"
        #print "audio : " + path
        document.setTitleText_("Installing audio ...")
        count = self.getFilesCount(os.path.join(document.getResPath(),"audio"))
        print count
        document.setRange_(count+1)
        for f in os.listdir(os.path.join(document.getResPath(),"audio")):
            document.stepIt_(f)
            self.itunes.add(path+f, to = playList)
        # self.itunes.update()
        print "Copy done ... "
        document.setTitleText_("Installing notes ...")
        if iPodDir:
            path = os.path.join(iPodDir,"Notes.0")
            path=self.repairPath(path)
            n = 0
            while (os.path.exists(path)):
                n+=1
                path = os.path.join(iPodDir,"Notes."+ str(n))
                path = self.repairPath(path)
            #print path
            destPath = os.path.join(iPodDir, "Notes")
            destPath = self.repairPath(destPath)
            #print destPath
            if os.path.exists(destPath):
                os.rename(destPath, path)
            else:
                print destPath + " doesn't exists"
            command = "mkdir " + destPath
            #print command
            os.system(command)
            #os.mkdir(destPath)
            #print "mkdir " + destPath
            iPodNotesSrc = os.path.join(document.getResPath(),"Notes/*")
            iPodNotesSrc = self.repairPath(iPodNotesSrc)
            print iPodNotesSrc
            print destPath
            document.setTitleText_("Installing Notes ...")
            document.stepIt_("Notes")
            command = "cp -R " + iPodNotesSrc + " " + destPath
            print command
            os.system(command)
            document.stepIt_("Instalation done")
            document.setTitleText_("Installation done.")
            document.messageBox_("Setup has finished instalation.")
            document.close()